petsc-3.7.1 2016-05-15
Report Typos and Errors

# MatMatMult

Performs Matrix-Matrix Multiplication C=A*B.

### Synopsis

    #include "petscmat.h"
    PetscErrorCode MatMatMult(Mat A,Mat B,MatReuse scall,PetscReal fill,Mat *C)

Neighbor-wise Collective on Mat Many br

### Input Parameters

| A | - the left matrix Many br
| B | - the right matrix Many br
| scall | - either MAT_INITIAL_MATRIX or MAT_REUSE_MATRIX Many br
| fill | - expected fill as ratio of nnz(C)/(nnz(A) + nnz(B)), use PETSC_DEFAULT if you do not have a good estimate Many brif the result is a dense matrix this is irrelevent Many br

### Output Parameters

C -the product matrix Many br

### Notes

Unless scall is MAT_REUSE_MATRIX C will be created. Many br

MAT_REUSE_MATRIX can only be used if the matrices A and B have the same nonzero pattern as in the previous call Many br

To determine the correct fill value, run with -info and search for the string "Fill ratio" to see the value Many bractually needed. Many br

If you have many matrices with the same non-zero structure to multiply, you Many brshould either Many br

      1) use MAT_REUSE_MATRIX in all calls but the first or

      2) call MatMatMultSymbolic() once and then MatMatMultNumeric() for each product needed

In the special case where matrix B (and hence C) are dense you can create the correctly sized matrix C yourself and then call this routine Many brwith MAT_REUSE_MATRIX, rather than first having MatMatMult() create it for you. You can NEVER do this if the matrix C is sparse. Many br

Many br

### See Also

MatMatMultSymbolic(), MatMatMultNumeric(), MatTransposeMatMult(), MatMatTransposeMult(), MatPtAP()

Level:intermediate
Location:src/mat/interface/matrix.c
Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages

### Examples

src/snes/examples/tutorials/ex70.c.html